
#ifndef IDE_THIS
#define IDE_THIS

#include "Unit1.h"
#include "Unit2.h"
#include "Unit6.h"
#include "Unit7.h"
#include "Unit8.h"
#include "Unit9.h"
#include "Unit10.h"
#include "ob.h"

#include <mstore.h>
#include <mvect.h>
#include "menum.h"

typedef mstore_dynamicalloc<ob_type_arraysize,ob_type_arraydimension> ide_menum_type_d;
typedef mvect_common<ide_menum_type_d>                                ide_menum_type_s;

typedef menum_common<ide_menum_type_s>                  menumdef;

#define IDE_NULL (0)

void ide_writetomessageform(AnsiString* as,const TColor* col=IDE_NULL);
void ide_writetomessageform(char* ass,const TColor* col=IDE_NULL);

void ide_writetotherminalform(AnsiString* as,const TColor* col,bool flglue);

void ide_position(long p);

void ide_inputfromtherminal();

void ide_refreshformwithoutcondition(TForm* Tf);
void ide_refreshform(TForm* Tf);

AnsiString ide_watchlinereplacement(AnsiString* asw1,bool flevaluate=false);
void ide_watchlinereplacementwatch(bool flevaluate=false);

bool ide_basicloadfile();

AnsiString ide_catchservice(ob_err& e);

const int ide_maxcountlineform=1000;
const unsigned int ide_sleepperiodms=1000;
const unsigned int ide_numsleepperiod=10;

const ob_type_stringsize ide_maxlengthstring=ob_maxlengthstring;

const TColor ide_errrorcatchcolor=clRed;
const TColor ide_errroridecolor=clPurple;
const TColor ide_cursorcolor=clBlue;
const TColor ide_errorrnoactionrun=clRed;

const unsigned int ide_defaultanimateperiod=1000;

class ide_configdef{

bool flloadmodified;

public:

static char* configfilename1;
static char* watchlistfilename;

AnsiString fullconfigfilename1;
AnsiString fullwatchlistfilename;

AnsiString currdir;
AnsiString currdirhtm;
AnsiString currdirbas;

AnsiString ide_title;
AnsiString currentfilename1;
void initcurrentfilename(){currentfilename1="new.bas";}

ide_configdef(){
initcurrentfilename();
}

void setflloadmodified(bool f){
flloadmodified=f;
if(flloadmodified==true){
Form2->StatusBar1->Panels->Items[1]->Text="Edit!=Load";
}//if
else{
Form2->RichEdit1->Modified=false;
Form2->StatusBar1->Panels->Items[1]->Text="Edit==Load";
}//else
}

bool getflloadmodified(){return flloadmodified;}

};

extern ide_configdef ide_config;

class ide_currentpositionform{
int top;
int left;
int height;
int width;
bool flvisible;

public:

void getpos(TForm* form){
top=form->Top;
left=form->Left;
height=form->Height;
width=form->Width;
flvisible=form->Visible;
}

void setpos(TForm* form){
form->Top=top;
form->Left=left;
form->Height=height;
form->Width=width;
form->Visible=flvisible;
}

void write(ostream& st){
st.write((char*)this,sizeof(*this));
}

void read(istream& st){
st.read((char*)this,sizeof(*this));
}

};

class ide_currentpositiondef{
public:

ide_currentpositionform main;
ide_currentpositionform form1terminal;
ide_currentpositionform form3watch;
ide_currentpositionform form5messages;

unsigned int fontsize1;

void tofile(char* name);
bool fromfile(char* name);

void setfontsize(int fs){
fontsize1=fs;
setfontsize();
}

void setanimateperiod(int ap);

void setfontsize(){
Form2->RichEdit1->Font->Size=fontsize1;
Form7->RichEdit1->Font->Size=fontsize1;
Form8->RichEdit1->Font->Size=fontsize1;
Form9->RichEdit1->Font->Size=fontsize1;
}

};

class ide_thread_wrapperdef{

ide_load_run_threaddef* threadptr;

public:

ob_obasic interpreter;

AnsiString runtmpname;

ide_thread_wrapperdef();

ide_load_run_threaddef* getptr(){return threadptr;}

void createnewthread(){

threadptr=new ide_load_run_threaddef(true);
threadptr->FreeOnTerminate=true;

threadptr->setparam(&interpreter,runtmpname.c_str());

threadptr->Priority=tpLower;

resu();//need this action because thread create suspended
}

void susp();
void resu();

void kill(){
susp();
TerminateThread((void*)threadptr->Handle,0);
threadptr=IDE_NULL;
createnewthread();
}

~ide_thread_wrapperdef(){
}

void runbasic(
ide_load_run_threaddef::actionflagdef a,bool fla=false){
threadptr->setanimateflag(fla);
threadptr->setactionflag(a);
resu();
}

bool checkexecutewithoutbox(){
if(
((threadptr->Suspended==true)&&
(threadptr->getactionflag()==ide_load_run_threaddef::noaction)))
return true;
else
return false;
}

private:

bool checkexecute(char* msg){
bool fl=checkexecutewithoutbox();
if(fl==false)
ide_writetomessageform(msg,&ide_errroridecolor);
return fl;
}

public:

bool checkexecute1(){
return checkexecute("Open Basic is running. Press Stop or Abort");
}

bool checkexecute(){
bool fl=checkexecute1();
if(fl==true){
fl=fl&&(!ide_config.getflloadmodified());
  if(fl==false){
  ide_writetomessageform("Edit file modified or not Basic loaded. Please reload for run",&ide_errroridecolor);
  }//if
}//if
return fl;
}

};

class ide_inputfromterminalclassdef{
public:
ide_inputfromterminalclassdef():flstartinput(false),lengthprevstring(0){}
bool flstartinput;
AnsiString string;
int lengthprevstring;
};

template <class T,class count=unsigned int>
class ide_wrapper{
T* ptr;
public:
ide_wrapper(count c){ptr=new T[c];}
T* get(){return ptr;}
~ide_wrapper(){delete[] ptr;}
};

extern ide_currentpositiondef ide_currentposition;
extern ide_configdef ide_config;
extern ide_thread_wrapperdef ide_thread_wrapper;
extern ide_inputfromterminalclassdef ide_inputfromterminalclass;

template <class T> bool ide_convert(T* v,AnsiString* val){

istrstream is(val->c_str());

is>>*v;

long sp=is.tellg();

if(sp==-1) return false; else return true;
}

//convert separately over *stream because AnsiString use local for convert
template <class T> void ide_convert(AnsiString* val,T v){

ostrstream os;

os<<v<<ends;

*val=os.str();
os.freeze();
}

#endif

